package gui;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Event handler class for Zoom out events. The zo HashMap entry for the zoom in level is retrieved and replotted by
 * resetting xrange and yrange for the GNUPlot
 * 
 * @author Natasha Gaitonde - gaitonde@email.arizona.edu
 *
 */
public class CSIZOBTN implements ActionListener
{
	CSIPlotMain cpm;
	CSIZOBTN (CSIPlotMain cptemp)
	{
		cpm = cptemp;
	}
	public void actionPerformed(ActionEvent event)
	{
		if(cpm.zilevel>0)//Zoomed in by atlest one level
		{
			cpm.gnuPlotScript(cpm.zilevel,0);
			cpm.drawImage();
		}
	}
}
