#ifndef __A3D_H__
#define __A3D_H__


/*ODBC support*/
#include <sql.h>
#include <sqlext.h>

#include "db.h"
/* TT support */
typedef struct timeval TV;
//#include "shqueue.h"
//#include "db_int.h"
//#include "aud_int.h"
//#include "heap.h"

/*BEECRYPT support*/
#include "sha1.h"


#include "common.h"
#include "red_black_tree.h"

void A3DgetValID(SQLHDBC dbc, char *stopValID, char *stopNotID);

void A3DgetNIDfromChain(SQLHDBC dbc,char *nid_value, char *EventID,char *startActDate, char *startActMs, char *stopActDate, char *stopActMs);

void A3Dhelper(SQLHDBC dbc,char chaintype,int subscript, int superscript, int Cheight, int *Cset, int *topCpt, char *server, in_port_t port);

int A3DvalCheckChain(SQLHDBC dbc,char chaintype,char *chainID, char *server, in_port_t port);

int A3DexistChain(SQLHDBC dbc,char chaintype,int subscript, int superscript,char *chainID);

void A3DgetNotID(SQLHDBC dbc, char *stopNotID, int subscript);
void A3DPartialChain(SQLHDBC dbc, char *server, in_port_t port);
void A3DinsertChain(SQLHDBC dbc, char *startActDate, char *startactualms, char *stopActDate, char *stopactualms,char *hash_value, NID nid);

NID A3DcalChainNID(SQLHDBC dbc, char *startActDate, char *startactualms, char *stopActDate, char *stopActMs, char *server, in_port_t port, char *hash_value);

void getChainStart(SQLHDBC dbc, int length, char *stopNotID, char *startSchDate,char *startActDate, char *startactualms);

int A3DpowerOf2(int granule);

int A3DgetPower(int exp);


#endif
