#ifndef __VALIDATOR_H__
#define __VALIDATOR_H__

#include <sql.h>
#include <sqlext.h>

/*typedef struct Column
{
    char ColName[50];
    int ColNum;
    union UnionValue {
        int iValue;
        char sValue[50];
    }Value;
} ConfigCol;

ConfigCol Column[6];
*/

void InitConfigTable();
void PrintConfigTable();
void ReadConf(SQLHDBC dbc);
void ErrorCheck(void);
static int print_tol();
//NID getNIDfromChain(SQLHDBC dbc,char *hash_value);
//void getNIDfromChain(SQLHDBC dbc,char *nid_value, char *EventID);

int rebuild_tol(struct timeval start_val,struct timeval stop_val);

void getStart(char *prevactualdate, char *prevactualtime, char *prevactualms);

void getStop(SQLHDBC dbc, char *stopSchDate,char *stopActDate, char *stopactualms, char *stopEventID);

struct timeval mkCalTime(char *date, char *time, char *ms);

//rui's functions and definitions
//int CreateSortedRuns(
//    int prefix, struct timeval start_val,struct timeval stop_val);

typedef struct Key {
  struct timeval txn_time;
  int seq_num;
  int high_seq_num;
  int is_hashed; // if is_hashed is set, value will be the hash value instead
                 // of the original data
  int value_size;
} Key;

typedef struct Record {
  Key key;
  void* value;
} Record;

#endif

