package gui;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.HashMap;
@SuppressWarnings("serial") 
public class CSIPlotDB 
{
	Connection con = null;
	PreparedStatement ps = null;
	ResultSet rs = null;
	CSIPlotDB()
	{
		con=Connector.getConnection();
	}
	HashMap findCorruptions (String dbname, String dbpath)
	{
		HashMap hm = new HashMap();
		PreparedStatement psInner = null;
		ResultSet rsInner = null;
		CSIPlotCorruption zc = null;
		int count=0;
		hm.clear();
		try
		{
			StringBuffer query= new StringBuffer("SELECT EventID " +
					"FROM Event " +
					"WHERE Name='" + dbname + "' " +
							"AND Path='" + dbpath + "' " +
									"AND Kind='T' " +
									"ORDER BY EventID");
			ps = con.prepareStatement(query.toString());
			rs = ps.executeQuery();
			while(rs.next())
			{
				StringBuffer queryInner = new StringBuffer("SELECT * " +
						"FROM SynchronizedRegion " +
						"WHERE EventID=" + rs.getInt("EventID"));
				psInner = con.prepareStatement(queryInner.toString());
				rsInner = psInner.executeQuery();
				while(rsInner.next())
				{
					zc = new CSIPlotCorruption();
					zc.setEventID(rsInner.getInt("EventID"));
					zc.setTopLeftX(rsInner.getInt("TopLeftX"));
					zc.setTopLeftY(rsInner.getInt("TopLeftY"));
					zc.setTopRightX(rsInner.getInt("TopRightX"));
					zc.setTopRightY(rsInner.getInt("TopRightY"));
					zc.setBottomLeftX(rsInner.getInt("BottomLeftX"));
					zc.setBottomLeftY(rsInner.getInt("BottomLeftY"));
					zc.setBottomRightX(rsInner.getInt("BottomRightX"));
					zc.setBottomRightY(rsInner.getInt("BottomRightY"));
					hm.put(new Integer(count++),zc);
				}					
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return hm;
	}
	ResultSet findActualDate (int EventID, String dbname, String dbpath, String kind)
	{
		try
		{
			StringBuffer query= new StringBuffer("SELECT ActualDate " +
					"FROM Event " +
					"WHERE Name='" + dbname + "' " +
							"AND Path='" + dbpath + "'");
			if(kind!=null && !kind.equalsIgnoreCase(""))
			{
				query.append(" AND Kind='" + kind + "'");
			}
			if(EventID>0)
			{
				query.append(" AND EventID='" + EventID + "'");
			}
			query.append(" AND ActualDate !='0000-00-00 00:00:00'");
			query.append(" ORDER BY ActualDate");
			ps = con.prepareStatement(query.toString());
			rs = ps.executeQuery();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return rs;
	}	
}